﻿local E = AleaUI
local CBF = E:Module("ClassBars")

local class1, class = UnitClass("player")
if class ~= "DRUID" and class ~= "ROGUE" then return end

local w, h = 50, 10
local maxw, maxh = 200, 10

local NUM_COMBO = 8

local color = { 
	[1] = { 255/255, 213/255, 0, 1},
	[2] = { 255/255, 213/255, 0, 1},
	[3] = { 255/255, 171/255, 0, 1},
	[4] = { 255/255, 171/255, 0, 1},
	[5] = { 255/255, 107/255, 0, 1},
	[6] = { 255/255, 107/255, 0, 1},
	[7] = { 255/255, 107/255, 0, 1},
	[8] = { 255/255, 107/255, 0, 1},	
 }


local function ComboBar()

	local f = CreateFrame("Frame", nil, E.UIParent)
	E:Mover(f, "combopointFrame")

	f.eventlist = {
		["UNIT_POWER_FREQUENT"]		= "player",
		["UNIT_COMBO_POINTS"]		= "",
		["PLAYER_TARGET_CHANGED"]   = "",

		["PLAYER_ENTERING_WORLD"]	= '',
		["UPDATE_SHAPESHIFT_FORM"]	= '',
		["PLAYER_TALENT_UPDATE"]	= '',
	
		}

	f:Show()
	f:EnableMouse(false)
	
	f:SetSize(maxw, maxh)
	
	local o = CreateFrame("StatusBar", nil, f)
	o:SetParent(f)
	o:SetFrameLevel(f:GetFrameLevel()+1)
	o:SetSize(maxw, maxh)
	o:SetStatusBarTexture([[Interface\Buttons\WHITE8x8]])
	o:SetPoint("LEFT", f, "LEFT", 0, 0)
	o:SetStatusBarColor(unpack(color[1]))
	o:SetMinMaxValues(0,NUM_COMBO)
	
	o.art = CreateFrame("Frame", nil, o)
	o.art:SetFrameLevel(o:GetFrameLevel()-1)
	o.art:SetBackdrop({
	  bgFile = [[Interface\Buttons\WHITE8x8]], 
	  edgeFile = [[Interface\Buttons\WHITE8x8]], 
	  edgeSize = 1, 
	})
	o.art:SetBackdropColor(color[1][1]*0.4,color[1][2]*0.4,color[1][3]*0.4, 1)
	o.art:SetBackdropBorderColor(0,0,0,1)
	o.art:SetPoint('TOPLEFT', o, 'TOPLEFT', -1, 1)
	o.art:SetPoint('BOTTOMRIGHT', o, 'BOTTOMRIGHT', 1, -1)
	
	f.bar = o
	
	f.bar.separators = {}
	
	for i=1, NUM_COMBO-1 do
		local s = f.bar:CreateTexture()
		s:SetDrawLayer('ARTWORK', 1)
		s:SetSize(1, maxh)
		s:SetColorTexture(0,0,0,1)
		s:SetPoint('LEFT', f.bar, 'LEFT', maxw/NUM_COMBO*i, 0)
		
		f.bar.separators[i] = s
	end
	
	local lastMaxCombo = -1
	
	function f:UNIT_COMBO_POINTS(event, unit)
		local number = UnitPower("player", 4)
		local maxCombo = UnitPowerMax("player", 4)
		
		if CBF:GetOptions('visability') == 1 then
			if not f.bar:IsShown() then
				f.bar:Show()
			end
		elseif CBF:GetOptions('visability') then
			if UnitExists('target') then
				if not f.bar:IsShown() then
					f.bar:Show()
				end
			else
				if f.bar:IsShown() then
					f.bar:Hide()
				end
			end
		end
		
		if maxCombo == 0 then return end
		
		if lastMaxCombo ~= maxCombo then
			lastMaxCombo = maxCombo
			
			local width = f.bar:GetWidth()/lastMaxCombo
			
			for i=1, lastMaxCombo-1 do
				f.bar.separators[i]:SetPoint('LEFT', f.bar, 'LEFT', width*i, 0)
				f.bar.separators[i]:Show()
			end
			
			for i=lastMaxCombo, #f.bar.separators do
				f.bar.separators[i]:Hide()
			end
		end
		
		f.bar:SetMinMaxValues(0, maxCombo)
		f.bar:SetValue(number)
	end

	f.PLAYER_TARGET_CHANGED = f.UNIT_COMBO_POINTS
	f.UNIT_POWER_FREQUENT = f.UNIT_COMBO_POINTS
	
	function f:PLAYER_ENTERING_WORLD()	
		f:UNIT_COMBO_POINTS(event, unit)
		
		if class ~= 'DRUID' then return end
		local form  = GetShapeshiftFormID();
		
		if form == CAT_FORM then
			self:Show()
		else
			self:Hide()
		end
	end
	
	f.UPDATE_SHAPESHIFT_FORM = f.PLAYER_ENTERING_WORLD
	f.PLAYER_TALENT_UPDATE = f.PLAYER_ENTERING_WORLD

	function f:UpdateStyle()
		local opts = CBF:GetOptions()
		f:SetSize(opts.width, opts.height)
		
		f.bar:SetSize(opts.width, opts.height)
		f.bar:SetStatusBarTexture(E:GetTexture(opts.texture))
		
		local combos  = UnitPowerMax("player", 4)
		local width = f.bar:GetWidth()/combos
			
		for i=1, combos-1 do
			f.bar.separators[i]:SetPoint('LEFT', f.bar, 'LEFT', width*i, 0)
			f.bar.separators[i]:Show()
		end
		
		for i=combos, #f.bar.separators do
			f.bar.separators[i]:Hide()
		end
			
		for i=1, #f.bar.separators do
			f.bar.separators[i]:SetSize(1, opts.height)
		end
	end
	
	
	f.Update = function(self)	
		self:PLAYER_TARGET_CHANGED()	
		f:UpdateStyle()
	end
	
	f:Update()
	
	E.GUI.args.unitframes.args.classBars.args.unlock = {
		name = "Разблокировать",
		order = 2,
		type = "execute",
		set = function(self, value)
			E:UnlockMover("combopointFrame") 
		end,
		get = function(self)end
	}
	
	E.GUI.args.unitframes.args.classBars.args.width = {
		name = 'Ширина',
		order = 3,
		type = 'slider',
		min=1, max = 600, step = 1,
		set = function(info, value)
			CBF:SetOptions('width', value)
			f:UpdateStyle()
		end,
		get = function(info)
			return CBF:GetOptions('width')
		end,
	}
	
	E.GUI.args.unitframes.args.classBars.args.height = {
		name = 'Высота',
		order = 4,
		type = 'slider',
		min=1, max = 600, step = 1,
		set = function(info, value)
			CBF:SetOptions('height', value)
			f:UpdateStyle()
		end,
		get = function(info)
			return CBF:GetOptions('height')
		end,
	}
	
	E.GUI.args.unitframes.args.classBars.args.texture = {
		order = 5,
		type = 'statusbar',
		name = "Текстура",
		values = E.GetTextureList,
		set = function(info,value) 
			CBF:SetOptions('texture', value)
			f:UpdateStyle()
		end,
		get = function(info) 
			return CBF:GetOptions('texture')
		end,
	}
	
	E.GUI.args.unitframes.args.classBars.args.visability = {
		order = 5,
		type = 'statusbar',
		name = "Отображение",
		values = {
			'Всегда',
			'Цель существует',
		},
		set = function(info,value) 
			CBF:SetOptions('visability', value)
			f:UpdateStyle()
		end,
		get = function(info) 
			return CBF:GetOptions('visability')
		end,
	}
	
	return f
end



CBF:AddClassBar(class, 1, ComboBar)
CBF:AddClassBar(class, 2, ComboBar)
CBF:AddClassBar(class, 3, ComboBar)

if class == "DRUID" then
	CBF:AddClassBar(class, 4, ComboBar)
end